#ifndef _LBBCENTITYTEXTUREATLASVIEWMODE_H
#define _LBBCENTITYTEXTUREATLASVIEWMODE_H

#include <LBBCPrerequisites.h>
#include <IMG.h>
#include <OBAOgreFrameListenerMode.h>

namespace LBBC {

class _BBCExport EntityTextureAtlasViewMode : public OBA::OgreFrameListenerMode 
{
	protected:
		Ogre::SceneNode* mTextureAtlasNode;

		IMG::TextureAtlasPtr mTextureAtlas;

		unsigned int mFrame;

		bool mTextureAtlasGenerated;

		unsigned int mBitRange;

		Ogre::PixelFormat mSrcPixelFormat;

		Ogre::PixelFormat mDestPixelFormat;

		Ogre::String mTextureName;

		Ogre::String mTextureAtlasName;

		Ogre::String mTextureAtlasFolder;

		unsigned int mTextureAtlasSize;

		unsigned int mNumSamples;

	public:
		EntityTextureAtlasViewMode(Ogre::RenderWindow* win, unsigned int ogreFrameListenerModeHandle, bool useBufferedInputKeys = false, bool useBufferedInputMouse = false);

		virtual ~EntityTextureAtlasViewMode();		

		void setTextureAtlasFolder(Ogre::String textureAtlasFolder);

		unsigned int nextPowerOf2(unsigned int nPlanes);

		virtual bool frameStarted(const Ogre::FrameEvent& evt, Ogre::InputReader *inputReader);

		virtual void createScene();

		virtual void destroyScene();

		void setTextureAtlasBitRange(unsigned int bitRange);

		void setTextureAtlasNumSamples(unsigned int numSamples);

		void setTextureName(Ogre::String textureName);

		void setTextureAtlasName(Ogre::String textureAtlasName);

		void setTextureAtlasSize(unsigned int size);
};

}
#endif
