#ifndef _LBBCMANAGER_H
#define _LBBCMANAGER_H

#include <LBBCPrerequisites.h>
#include <LBBCLeaves.h>
#include <LBBCLeafDistribution.h>
#include <LBBCLeafDistributionGenerator.h>
#include <LBBCLeafDistributionSerializer.h>
#include <LBBCKdTreeClusterGenerator.h>
#include <LBBCKMeansClusterGenerator.h>
#include <LBBCKdTreeClusterSerializer.h>
#include <LBBCKMeansClusterSerializer.h>
#include <LBBCSampleConfigFile.h>

namespace LBBC {

class _BBCExport LBBCManager : public BBC::BBCManager {
  public:
    LBBCManager();

    ~LBBCManager();

	void runSampleConfigFile();

	void loadSampleConfigFile(Ogre::String sampleConfigFile);

	SampleConfigFile* getSampleConfigFile();

	void setSampleConfigFile(SampleConfigFile *sampleConfigFile);

	void generateEntityDistribution();

	void loadEntityDistribution();

	void saveEntityDistributionSplitted();

	void createEntityDistribution();

	void saveEntityDistributionXML();		

	void generateEntityClusters();

	void createEntityClusters();

	void saveEntityClusters();

	void saveSingleEntity();
	
	void generateBillboardCloud();

	void saveBillboardCloudGrouped();

	void saveBillboardCloudSplitted();

	void saveBillboardCloudMerged();

	void saveBillboardCloudXML();

	Leaves* getLeaves();

  protected:

	LBBC::Leaves *mLeaves;

	LBBC::LeafDistributionSerializer *mLeafDistributionSerializer;

	LBBC::LeafDistributionGenerator *mLeafDistributionGenerator;

	BBC::BillboardCloudGenerator *mBillboardCloudGenerator;

	BBC::BillboardCloudSerializer *mBillboardCloudSerializer;

	BBC::BillboardCloudUVMapper *mBillboardCloudUVMapper;

	BBC::OgreMeshSerializer *mOgreMeshSerializer;

	SampleConfigFile *mSampleConfigFile;

	Ogre::ConfigFile *mConfigFile;

};

}
#endif
